# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free

Name:           day-jcr-1.0-api
Version:        1.0
Release:        2%{?dist}
Epoch:          0
Summary:        Content Repository for Java Technology (JSR-170) API

Group:          Development/Libraries/Java
License:        Freely distributable source
URL:            http://www.jcp.org/en/jsr/detail?id=170
Source0:        http://repo1.maven.org/maven2/javax/jcr/jcr/1.0/jcr-1.0-sources.jar
Source1:        http://repo1.maven.org/maven2/javax/jcr/jcr/1.0/jcr-1.0.pom
Source2:        http://www.day.com/maven/jsr170/jars/LICENSE.txt

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7

Requires:  java >= 0:1.6.0
Provides:  jcr_1_0_api = %{epoch}:%{version}-%{release}

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
Specifies a standard API to access content repositories in 
JavaTM 2 independently of implementation.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}


%prep
%setup -q  -c
mkdir -p target/site/apidocs/
mkdir -p target/classes/
mkdir -p src/main/java
mv javax src/main/java
mv META-INF target/classes
cp %{SOURCE2} target/classes/META-INF/additional-LICENSE.txt


%build
export LANG=en_US.utf8
unset CLASSPATH

%{java_home}/bin/javac -d target/classes $(find src/main/java -name "*.java")
%{java_home}/bin/javadoc -d target/site/apidocs -sourcepath src/main/java javax.jcr javax.jcr.lock javax.jcr.nodetype javax.jcr.observation javax.jcr.query javax.jcr.util javax.jcr.version

pushd target/classes
%{java_home}/bin/jar cf ../%{name}-%{version}.jar *
popd


%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 target/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap javax.jcr jcr %{version} JPP %{name}
ln -sf %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar


# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
update-alternatives --install %{_javadir}/jcr_1_0_api.jar jcr_1_0_api %{_javadir}/%{name}-%{version}.jar 10000

%preun
if [ "$1" = "0" ]; then
    update-alternatives --remove jcr_1_0_api %{_javadir}/%{name}-%{version}.jar
fi

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%{_javadir}/*.jar
%doc target/classes/META-INF/*LICENSE.txt
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}


%changelog
* Mon Oct 04 2010 Ralph Apel <r.apel at r-apel.de> - 0:1.0-2
- First JPP-6 release
 
* Thu Jul 17 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.0-1.jpp5
- First release
 
